// II_SERIAL.CS serialport class@author nobumichi harasawa
//t@C@NX
#if MENU||TIME
using System;
using System.IO.Ports;
using System.Text;
//=============================================
public class serialport_l
{z_l z_n;SerialPort SerialPort_n=null;
public string file_s="",data_s="";
public serialport_l(z_l z_ni){z_n=z_ni;}
public bool write_b(string data_si)
{if(null==SerialPort_n){z_n.err_s="Write/Not Open";return false;}
try{SerialPort_n.Write(data_si);} 
catch(Exception e_t){z_n.err_s="write_b("+file_s+")"+e_t.Message;close_v();return false;}
return true;
}
//----------------------------------------------
//***( return 0=normal,1=At end,5=error )***
public int read(int i_ii)
{
if(null==SerialPort_n){z_n.err_s="serialport/Not Open";return 5;}
try{char[] cx=new char[i_ii];
    SerialPort_n.Read(cx,0,i_ii);
    data_s=new String(cx);
   } 
catch(Exception e_t){z_n.err_s="serialport("+file_s+")"+e_t.Message;close_v();return 5;}
return 0;
}
//----------------------------------------------
public bool open_b(string s1_si,string s2_si)
{if(null!=SerialPort_n){z_n.err_s="serialport("+file_s+")/serialporty open";return false;}
string[] sx=s1_si.Split(',');
file_s=sx[0];
int rate=9600; if(1<sx.Length)if(false==z_n.to_int_b(ref rate,sx[1],'-'))return false;
Parity Parity_n;
switch(2<sx.Length?sx[2].ToUpper():"NONE")
  {
case "EVEN": Parity_n=Parity.Even;break;
case "MARK": Parity_n=Parity.Mark;break;
case "NONE": Parity_n=Parity.None;break;
case "ODD":  Parity_n=Parity.Odd;break;
case "SPACE":Parity_n=Parity.Space;break;
default:z_n.err_s="serialport(Parity="+sx[2]+")NG(EVEN,MARK,NONE,ODD,SPACE)";return false;
  }
int data_bit=8;if(3<sx.Length)if(false==z_n.to_int_b(ref data_bit,sx[3],'-'))return false;
StopBits StopBits_n;
switch(4<sx.Length?sx[4].ToUpper():"ONE")
  {
case "NONE":        StopBits_n=StopBits.None;break;
case "ONE":         StopBits_n=StopBits.One;break;
case "ONEPOINTFIVE":StopBits_n=StopBits.OnePointFive;break;
case "TWO":         StopBits_n=StopBits.Two;break;
default:z_n.err_s="serialport(StopBits="+sx[4]+")NG(NONE,ONE,ONEPOINTFIVE,TWO)";return false;
  }
try{SerialPort_n=new SerialPort(file_s,rate,Parity_n,data_bit,StopBits_n);
    if(""!=s2_si)SerialPort_n.Encoding=z_n.Encoding_n(s2_si);
    SerialPort_n.Open();
    SerialPort_n.DtrEnable = true;
    SerialPort_n.RtsEnable = true;
   }
catch(Exception e_t)
{z_n.err_s="serialport("+file_s+")"+e_t.Message;close_v();SerialPort_n=null;return false;}
return true;
}
//----------------------------------------------
public void close_v()
{try{if(null!=SerialPort_n){SerialPort_n.Close();SerialPort_n.Dispose();SerialPort_n=null;}}
catch(Exception){}
}
}
#endif 
